
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ai_captionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_captions = await db.ai_captions.create(
            {
                id: data.id || undefined,
        
        caption_text: data.caption_text
        ||
        null
            ,
            
        confidence: data.confidence
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ai_captions.setMedia_item( data.media_item || null, {
            transaction,
        });
        
        await ai_captions.setAi_model( data.ai_model || null, {
            transaction,
        });
        
        await ai_captions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return ai_captions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ai_captionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                caption_text: item.caption_text
            ||
            null
            ,
            
                confidence: item.confidence
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ai_captions = await db.ai_captions.bulkCreate(ai_captionsData, { transaction });

        // For each item created, replace relation files
        

        return ai_captions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const ai_captions = await db.ai_captions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.caption_text !== undefined) updatePayload.caption_text = data.caption_text;
        
        
        if (data.confidence !== undefined) updatePayload.confidence = data.confidence;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await ai_captions.update(updatePayload, {transaction});

        
        
        if (data.media_item !== undefined) {
            await ai_captions.setMedia_item(
              
              data.media_item,
              
              { transaction }
            );
        }
        
        if (data.ai_model !== undefined) {
            await ai_captions.setAi_model(
              
              data.ai_model,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await ai_captions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return ai_captions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_captions = await db.ai_captions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ai_captions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ai_captions) {
                await record.destroy({transaction});
            }
        });


        return ai_captions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ai_captions = await db.ai_captions.findByPk(id, options);

        await ai_captions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ai_captions.destroy({
            transaction
        });

        return ai_captions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ai_captions = await db.ai_captions.findOne(
            { where },
            { transaction },
        );

        if (!ai_captions) {
            return ai_captions;
        }

        const output = ai_captions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.media_item = await ai_captions.getMedia_item({
            transaction
        });
        
        
        output.ai_model = await ai_captions.getAi_model({
            transaction
        });
        
        
        output.organizations = await ai_captions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.media_items,
        as: 'media_item',
        
        where: filter.media_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.media_item.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.media_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.ai_models,
        as: 'ai_model',
        
        where: filter.ai_model ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ai_model.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.ai_model.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.caption_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_captions',
                        'caption_text',
                        filter.caption_text,
                    ),
                };
            }
            

            
            

            
            if (filter.confidenceRange) {
                const [start, end] = filter.confidenceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    confidence: {
                    ...where.confidence,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    confidence: {
                    ...where.confidence,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ai_captions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ai_captions',
                        'caption_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ai_captions.findAll({
            attributes: [ 'id', 'caption_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['caption_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.caption_text,
        }));
    }

    
};

